Wt: Wt::WContainerWidget Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Public Member Functions | List of all members
Wt::WContainerWidget Class Reference

A widget that holds and manages child widgets. More...

`#include <Wt/WContainerWidget.h>`

Inheritance diagram for Wt::WContainerWidget:
[legend]

## Public Member Functions
| WContainerWidget ()
| Creates a container.
| ~WContainerWidget ()
| Destructor.
void | setLayout (std::unique_ptr< WLayout > layout)
| Sets a layout manager for the container.
template<typename Layout >
Layout * | setLayout (std::unique_ptr< Layout > layout)
| Sets a layout manager for the container, returning a raw pointer.
WLayout * | layout () const
| Returns the layout manager that was set for the container.
virtual void | addWidget (std::unique_ptr< WWidget > widget)
| Adds a child widget to this container.
template<typename Widget >
Widget * | addWidget (std::unique_ptr< Widget > widget)
| Adds a child widget to this container, returning a raw pointer.
template<typename Widget , typename ... Args>
Widget * | addNew (Args &&...args)
| Creates a widget and adds it, returning a reference to it.
virtual void | insertBefore (std::unique_ptr< WWidget > widget, WWidget *before)
| Inserts a child widget in this container, before another widget.
template<typename Widget >
Widget * | insertBefore (std::unique_ptr< Widget > widget, WWidget *before)
| Inserts a child widget to this container, before another widget, returning a raw pointer.
virtual void | insertWidget (int index, std::unique_ptr< WWidget > widget)
| Inserts a child widget in this container at given index.
template<typename Widget >
Widget * | insertWidget (int index, std::unique_ptr< Widget > widget)
| Inserts a child widget to this container at given index, returning a raw pointer.
template<typename Widget , typename ... Args>
Widget * | insertNew (int index, Args &&...args)
| Creates a widget and inserts it, returning a reference to it.
virtual std::unique_ptr< WWidget > | removeWidget (WWidget *widget) override
| Removes a child widget from this container.
virtual void | clear ()
| Removes all widgets.
virtual int | indexOf (WWidget *widget) const
| Returns the index of a widget.
virtual WWidget * | widget (int index) const
| Returns the widget at index
virtual int | count () const
| Returns the number of widgets in this container.
void | setContentAlignment (WFlags< AlignmentFlag > contentAlignment)
| Specifies how child widgets must be aligned within the container.
void | setPadding (const WLength &padding, WFlags< Side > sides=AllSides)
| Sets padding inside the widget.
WLength | padding (Side side) const
| Returns the padding set for the widget.
WFlags< AlignmentFlag > | contentAlignment () const
| Returns the alignment of children.
void | setOverflow (Overflow overflow, WFlags< Orientation > orientation=(Orientation::Horizontal|Orientation::Vertical))
| Sets how overflow of contained children must be handled.
void | setList (bool list, bool ordered=false)
| Renders the container as an HTML list.
bool | isList () const
| Returns if this container is rendered as a List.
bool | isUnorderedList () const
| Returns if this container is rendered as an Unordered List.
bool | isOrderedList () const
| Returns if this container is rendered as an Ordered List.
EventSignal< WScrollEvent > & | scrolled ()
| Event signal emitted when scrolling in the widget.
int | scrollTop () const
| return the number of pixels the container is scrolled horizontally
int | scrollLeft () const
| return the number of pixels the container is scrolled vertically
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
Public Member Functions inherited from Wt::WInteractWidget
| WInteractWidget ()
| Create an InteractWidget.
EventSignal< WKeyEvent > & | keyWentDown ()
| Event signal emitted when a keyboard key is pushed down.
EventSignal< WKeyEvent > & | keyPressed ()
| Event signal emitted when a "character" was entered.
EventSignal< WKeyEvent > & | keyWentUp ()
| Event signal emitted when a keyboard key is released.
EventSignal & | enterPressed ()
| Event signal emitted when enter was pressed.
EventSignal & | escapePressed ()
| Event signal emitted when escape was pressed.
EventSignal< WMouseEvent > & | clicked ()
| Event signal emitted when the primary mouse button was clicked on this widget.
EventSignal< WMouseEvent > & | doubleClicked ()
| Event signal emitted when the primary mouse button was double clicked on this widget.
EventSignal< WMouseEvent > & | mouseWentDown ()
| Event signal emitted when a mouse button was pushed down on this widget.
EventSignal< WMouseEvent > & | mouseWentUp ()
| Event signal emitted when a mouse button was released on this widget.
EventSignal< WMouseEvent > & | mouseWentOut ()
| Event signal emitted when the mouse went out of this widget.
EventSignal< WMouseEvent > & | mouseWentOver ()
| Event signal emitted when the mouse entered this widget.
EventSignal< WMouseEvent > & | mouseMoved ()
| Event signal emitted when the mouse moved over this widget.
EventSignal< WMouseEvent > & | mouseDragged ()
| Event signal emitted when the mouse is dragged over this widget.
EventSignal< WMouseEvent > & | mouseWheel ()
| Event signal emitted when the mouse scroll wheel was used.
EventSignal< WTouchEvent > & | touchStarted ()
| Event signal emitted when a finger is placed on the screen.
EventSignal< WTouchEvent > & | touchEnded ()
| Event signal emitted when a finger is removed from the screen.
EventSignal< WTouchEvent > & | touchMoved ()
| Event signal emitted when a finger, which is already placed on the screen, is moved across the screen.
EventSignal< WGestureEvent > & | gestureStarted ()
| Event signal emitted when a gesture is started.
EventSignal< WGestureEvent > & | gestureChanged ()
| Event signal emitted when a gesture is changed.
EventSignal< WGestureEvent > & | gestureEnded ()
| Event signal emitted when a gesture is ended.
void | setDraggable (const std::string &mimeType, WWidget *dragWidget=nullptr, bool isDragWidgetOnly=false, WObject *sourceWidget=nullptr)
| Configure dragging for drag and drop.
void | unsetDraggable ()
| Disable drag & drop for this widget.
void | setMouseOverDelay (int delay)
| Sets a delay for the mouse over event.
int | mouseOverDelay () const
| Returns the mouse over signal delay.
virtual void | setPopup (bool popup) override
| Lets the widget overlay over other sibling widgets.
virtual void | load () override
| Loads content just before the widget is used.
virtual bool | isEnabled () const override
| Returns whether the widget is enabled.
Public Member Functions inherited from Wt::WWebWidget
| WWebWidget ()
| Construct a WebWidget.
virtual std::vector< WWidget * > | children () const override
| Returns child widgets.
Signal & | childrenChanged ()
| Signal emitted when children have been added or removed.
virtual void | setPositionScheme (PositionScheme scheme) override
| Sets the CSS position scheme.
virtual PositionScheme | positionScheme () const override
| Returns the CSS position scheme.
virtual void | setOffsets (const WLength &offset, WFlags< Side > sides=AllSides) override
| Sets CSS offsets for a non-statically positioned widget.
virtual WLength | offset (Side s) const override
| Returns a CSS offset.
virtual void | resize (const WLength &width, const WLength &height) override
| Resizes the widget.
virtual WLength | width () const override
| Returns the width.
virtual WLength | height () const override
| Returns the height.
virtual void | setMinimumSize (const WLength &width, const WLength &height) override
| Sets a minimum size.
virtual WLength | minimumWidth () const override
| Returns the minimum width.
virtual WLength | minimumHeight () const override
| Returns the minimum height.
virtual void | setMaximumSize (const WLength &width, const WLength &height) override
| Sets a maximum size.
virtual WLength | maximumWidth () const override
| Returns the maximum width.
virtual WLength | maximumHeight () const override
| Returns the maximum height.
virtual void | setLineHeight (const WLength &height) override
| Sets the CSS line height for contained text.
virtual WLength | lineHeight () const override
| Returns the CSS line height for contained text.
virtual void | setFloatSide (Side s) override
| Specifies a CSS float side.
virtual Side | floatSide () const override
| Returns the CSS float side.
virtual void | setClearSides (WFlags< Side > sides) override
| Sets the sides that should be cleared of floats.
virtual WFlags< Side > | clearSides () const override
| Returns the sides that should remain empty.
virtual void | setMargin (const WLength &margin, WFlags< Side > sides=AllSides) override
| Sets CSS margins around the widget.
virtual WLength | margin (Side side) const override
| Returns a CSS margin set.
virtual void | setHiddenKeepsGeometry (bool enabled) override
| Sets whether the widget keeps its geometry when hidden.
virtual bool | hiddenKeepsGeometry () const override
| Returns whether the widget keeps its geometry when hidden.
virtual void | setHidden (bool hidden, const WAnimation &animation=WAnimation()) override
| Hides or shows the widget.
virtual bool | isHidden () const override
| Returns whether the widget is set hidden.
virtual bool | isVisible () const override
| Returns whether the widget is visible.
virtual void | setDisabled (bool disabled) override
| Sets whether the widget is disabled.
virtual bool | isDisabled () const override
| Returns whether the widget is set disabled.
virtual bool | isPopup () const override
| Returns whether the widget is overlayed.
virtual void | setInline (bool isInline) override
| Sets whether the widget is displayed inline or as a block.
virtual bool | isInline () const override
| Returns whether the widget is displayed inline or as block.
virtual void | setDecorationStyle (const WCssDecorationStyle &style) override
| Sets a CSS decoration style.
virtual WCssDecorationStyle & | decorationStyle () override
| Returns the decoration style of this widget.
virtual void | setStyleClass (const WString &styleClass) override
| Sets (one or more) CSS style classes.
virtual WString | styleClass () const override
| Returns the CSS style class.
virtual void | addStyleClass (const WString &styleClass, bool force=false) override
| Adds a CSS style class.
virtual void | removeStyleClass (const WString &styleClass, bool force=false) override
| Removes a CSS style class.
virtual bool | hasStyleClass (const WString &styleClass) const override
| Returns whether the widget has a style class.
virtual void | setVerticalAlignment (AlignmentFlag alignment, const WLength &length=WLength()) override
| Sets the vertical alignment.
virtual AlignmentFlag | verticalAlignment () const override
| Returns the vertical alignment.
virtual WLength | verticalAlignmentLength () const override
| Returns the fixed vertical alignment that was set.
virtual void | setToolTip (const WString &text, TextFormat textFormat=TextFormat::Plain) override
| Sets a tooltip.
virtual void | setDeferredToolTip (bool enable, TextFormat textFormat=TextFormat::Plain) override
| Enable deferred tooltip.
virtual WString | toolTip () const override
| Returns the tooltip.
virtual void | refresh () override
| Refresh the widget.
virtual void | setAttributeValue (const std::string &name, const WString &value) override
| Sets an attribute value.
virtual WString | attributeValue (const std::string &name) const override
| Returns an attribute value.
virtual void | setJavaScriptMember (const std::string &name, const std::string &value) override
| Sets a JavaScript member.
virtual std::string | javaScriptMember (const std::string &name) const override
| Returns the value of a JavaScript member.
virtual void | callJavaScriptMember (const std::string &name, const std::string &args) override
| Calls a JavaScript member.
virtual bool | loaded () const override
| Returns whether this widget has been loaded.
virtual void | setId (const std::string &id) override
| Sets the CSS Id.
virtual WWidget * | find (const std::string &name) override
| Finds a descendent widget by name.
virtual WWidget * | findById (const std::string &id) override
| Finds a descendent widget by id.
virtual void | setSelectable (bool selectable) override
| Sets as selectable.
virtual void | doJavaScript (const std::string &javascript) override
| Executes the given JavaScript statements when the widget is rendered or updated.
virtual const std::string | id () const override
| Returns the (unique) identifier for this object.
void | setLoadLaterWhenInvisible (bool)
| Change the way the widget is loaded when invisible.
std::string | htmlTagName () const
| returns the current html tag name
void | setHtmlTagName (const std::string &tag)
| set the custom HTML tag name
virtual void | setCanReceiveFocus (bool enabled) override
| Sets whether the widget can receive focus.
virtual bool | canReceiveFocus () const override
| Returns whether the widget can receive focus.
virtual bool | setFirstFocus () override
| Set focus on the widget's first descendant.
virtual void | setFocus (bool focus) override
| Sets focus.
virtual bool | hasFocus () const override
| Returns whether the widget currently has the focus.
virtual void | setTabIndex (int index) override
| Sets the tab index.
virtual int | tabIndex () const override
| Returns the tab index.
EventSignal & | blurred ()
| Signal emitted when the widget lost focus.
EventSignal & | focussed ()
| Signal emitted when the widget recieved focus.
virtual bool | scrollVisibilityEnabled () const final override
| Returns whether scroll visibility detection is enabled for this widget.
virtual void | setScrollVisibilityEnabled (bool enabled) final override
| Sets whether scroll visibility detection is enabled for this widget.
virtual int | scrollVisibilityMargin () const final override
| Returns the margin around the viewport within which the widget is considered visible.
virtual void | setScrollVisibilityMargin (int margin) final override
| Sets the margin around the viewport within which the widget is considered visible.
virtual Signal< bool > & | scrollVisibilityChanged () final override
| Signal triggered when the scroll visibility of this widget changes.
virtual bool | isScrollVisible () const final override
| Returns whether this widget is currently considered scroll visible.
virtual void | setThemeStyleEnabled (bool enabled) final override
| Sets whether theme styling for a widget is enabled or disabled.
virtual bool | isThemeStyleEnabled () const final override
| Returns whether this widget is currently styled by the chosen theme.
virtual void | setObjectName (const std::string &name) override
| Sets an object name.
void | setFocus ()
| Sets focus.
Public Member Functions inherited from Wt::WWidget
virtual | ~WWidget ()
| Destructor.
WWidget * | parent () const
| Returns the parent widget.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
std::unique_ptr< WWidget > | removeFromParent ()
| Removes the widget from its parent.
void | setWidth (const WLength &width)
| Sets the width.
void | setHeight (const WLength &height)
| Sets the height.
virtual void | positionAt (const WWidget *widget, Orientation orientation=Orientation::Vertical)
| Positions a widget next to another widget.
virtual void | toggleStyleClass (const WString &styleClass, bool add, bool force=false)
| Toggles a CSS style class.
std::string | jsRef () const
| Returns a JavaScript expression to the corresponding DOM node.
void | setFocus ()
| Sets focus.
virtual void | acceptDrops (const std::string &mimeType, const WString &hoverStyleClass=WString())
| Sets a mime type to be accepted for dropping.
virtual void | stopAcceptDrops (const std::string &mimeType)
| Indicates that a mime type is no longer accepted for dropping.
virtual void | htmlText (std::ostream &out)
| Streams the (X)HTML representation.
bool | isRendered () const
| Returns whether the widget is rendered.
void | hide ()
| Hides the widget.
void | animateHide (const WAnimation &animation)
| Hides the widget using an animation.
void | show ()
| Shows the widget.
void | animateShow (const WAnimation &animation)
| Shows the widget using an animation.
void | enable ()
| Enables the widget.
void | disable ()
| Disable thes widget.
bool | layoutSizeAware () const
| Returns whether the widget is layout size aware.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
virtual std::string | objectName () const
| Returns the object name.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Additional Inherited Members
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.
Static Public Member Functions inherited from Wt::WWebWidget
static std::string | jsStringLiteral (const std::string &v, char delimiter='\'')
| Turn a CharEncoding::UTF8 encoded string into a JavaScript string literal.
Static Public Member Functions inherited from Wt::WWidget
static WString | tr (const char *key)
| Short hand for WString::tr()
Static Public Member Functions inherited from Wt::WObject
Static Public Attributes inherited from Wt::WWidget
Protected Types inherited from Wt::WWebWidget
Protected Types inherited from Wt::WWidget
Protected Member Functions inherited from Wt::WInteractWidget
virtual void | propagateSetEnabled (bool enabled) override
| Propagates that a widget was enabled or disabled through children.
Protected Member Functions inherited from Wt::WWebWidget
virtual void | enableAjax () override
| Progresses to an Ajax-enabled widget.
virtual WStatelessSlot * | getStateless (Method method) override
| On-demand stateless slot implementation.
virtual void | render (WFlags< RenderFlag > flags) override
| Renders the widget.
Protected Member Functions inherited from Wt::WWidget
void | setLayoutSizeAware (bool sizeAware)
| Sets the widget to be aware of its size set by a layout manager.
virtual void | layoutSizeChanged (int width, int height)
| Virtual method that indicates a size change.
| WWidget ()
| Creates a widget.
virtual void | dropEvent (WDropEvent dropEvent)
| Handles a drop event.
virtual int | boxPadding (Orientation orientation) const
| Returns the widget's built-in padding.
virtual int | boxBorder (Orientation orientation) const
| Returns the widget's built-in border width.
void | scheduleRender (WFlags< RepaintFlag > flags=None)
| Schedules rerendering of the widget.
Protected Member Functions inherited from Wt::WObject
Protected Attributes inherited from Wt::WInteractWidget
Static Protected Attributes inherited from Wt::WInteractWidget
Static Protected Attributes inherited from Wt::WWidget

## Detailed Description

A widget that holds and manages child widgets.

A WContainerWidget acts as a container for child widgets. Child widgets may be added directly to the container or using a layout manager.

Use addWidget() or pass the container as constructor argument to a widget to directly add children to the container, without using a layout manager. In that case, CSS-based layout is used, and the resulting display is determined by properties of the children and the container. By default, a WContainerWidget is displayed as a block and manages its children within a rectangle. Inline child widgets are layed out in lines, wrapping around as needed, while block child widgets are stacked vertically. The container may add padding at the container edges using setPadding(), and provide alignment of contents using setContentAlignment(). A container is rendered by default using a HTML `div` tag, but this may be changed to an HTML `ul` or `ol` tag to make use of other CSS layout techniques, using setList(). In addition, specializations of this class as implemented by WAnchor, WGroupBox, WStackedWidget and WTableCell provide other alternative rendering of the container.

When setting the WContainerWidget inline the container only acts as a conceptual container, offering a common style to its children. Inline children are still layed out inline within the flow of the parent container of this container, as if they were inserted directly into that parent container. Block children are then not allowed (according to the HTML specification).

To use a layout manager instead of CSS-based layout, use setLayout() or pass the container as constructor argument to a layout manager. In that case you should not define any padding for the container, and widgets and nested layout managers must be added to the layout manager, instead of to the container directly.

Usage example:

// Example 1:
// Instantiate a container widget and add some children whose layout
// is governed based on HTML/CSS rules.
auto container1 = std::make_unique<Wt::WContainerWidget>();
container1->addWidget(std::make_unique<Wt::WText>("Some text"));
container1->addWidget(std::make_unique<Wt::WImage>("images/img.png"));
Wt::WContainerWidget *child3 = container1->addWidget(std::make_unique<Wt::WContainerWidget>());
// Example 2:
// Instantiate a container widget which uses a layout manager
auto container2 = std::make_unique<Wt::WContainerWidget>();
container2->resize(Wt::WLength::Auto, 600); // give the container a fixed height.
auto layout = std::make_unique<Wt::WVBoxLayout>();
layout->addWidget(std::make_unique<Wt::WText>("Some text"));
layout->addWidget(std::make_unique<Wt::WImage>("images/img.png"));
container2->setLayout(std::move(layout)); // set the layout to the container.
Wt::WContainerWidget
A widget that holds and manages child widgets.
Definition WContainerWidget.h:135
Wt::WContainerWidget::layout
WLayout * layout() const
Returns the layout manager that was set for the container.
Definition WContainerWidget.h:191
Wt::WContainerWidget::addWidget
virtual void addWidget(std::unique_ptr< WWidget > widget)
Adds a child widget to this container.
Wt::WLayout::addWidget
void addWidget(std::unique_ptr< WWidget > widget)
Adds the given widget to the layout.
Wt::WLength::Auto
static WLength Auto
An 'auto' length.
Definition WLength.h:65

When using a layout manager, you need to carefully consider the alignment of the layout manager with respect to the container: when the container's height is unconstrained (not specified explicitly using resize() or a style class, and the container is not included in a layout manager), you should pass AlignmentFlag::Top to setLayout().

### CSS

Depending on its configuration and usage, the widget corresponds to the following HTML tags:

- By default, the widget corresponds to a `<div>` tag.
- When configured with setInline(true), the widget corresponds to a `<span>`.
- When configured with setList(true), the widget corresponds to a `<ul>`.
- When configured with setList(true, true), the widget corresponds to a `<ol>`.
- When inserted into a container widget that isList(), the widget corresponds to a `<li>`.

This widget does not provide styling, and can be styled using inline or external CSS as appropriate.

## Member Function Documentation

## ◆ addNew()

template<typename Widget , typename ... Args>

Widget * Wt::WContainerWidget::addNew | ( | Args &&... | args | ) |

Creates a widget and adds it, returning a reference to it.

This is a useful shorthand for adding a new widget to the container, and getting a reference to it, e.g.:

Wt::WPushButton *button = container->addNew<Wt::WPushButton>("Click me!");
// do something with button, including safely using it in a lambda function
Wt::WPushButton
A widget that represents a push button.
Definition WPushButton.h:42

The implementation is equivalent to the following code:

std::unique_ptr<Widget> w{new Widget(std::forward<Args>(args)...)};
Widget *result = w.get();
addWidget(std::unique_ptr<WWidget>{std::move(w)});
return result;

There's an exception for global widgets, like WPopupWidget. In this case the implementation is equivalent to:

std::unique_ptr<Widget> w{new Widget(std::forward<Args>(args)...)};
Widget *result = w.get();
addChild(std::unique_ptr<WObject>(std::move(w)));
return result;
Wt::WObject::addChild
void addChild(std::unique_ptr< WObject > child)
Add a child WObject whose lifetime is determined by this WObject.

Since popup widgets (and similar widgets) are always and automatically placed in a global location in the widget tree, only their ownership is transferred.

## ◆ addWidget() [1/2]

template<typename Widget >

Widget * Wt::WContainerWidget::addWidget | ( | std::unique_ptr< Widget > | widget | ) |

Adds a child widget to this container, returning a raw pointer.

This is implemented as:

Widget *result = widget.get();
addWidget(std::unique_ptr<WWidget>(std::move(widget)));
return result;
Wt::WContainerWidget::widget
virtual WWidget * widget(int index) const
Returns the widget at index

This is a useful shorthand to add a widget and get a raw pointer to it, e.g.:

Wt::WPushButton *button = container->addWidget(std::make_unique<Wt::WPushButton>("Click me!"));
// do something with button, including safely using it in a lambda function

## ◆ addWidget() [2/2]

virtual void Wt::WContainerWidget::addWidget | ( | std::unique_ptr< WWidget > | widget | ) |
| virtual

Adds a child widget to this container.

The widget is appended to the list of children, and thus also layed-out at the end.

If, for some reason, you want to be in control of the lifetime of the widget, you can retrieve a unique_ptr with WObject::removeChild()

Reimplemented in Wt::WStackedWidget.

## ◆ clear()

virtual void Wt::WContainerWidget::clear | ( |  | ) |
| virtual

Removes all widgets.

This removes all children that have been added to this container. If a layout was set, also the layout manager is cleared.

## ◆ contentAlignment()

WFlags< AlignmentFlag > Wt::WContainerWidget::contentAlignment | ( |  | ) | const

Returns the alignment of children.

See also
  setContentAlignment(WFlags<AlignmentFlag>)

## ◆ insertBefore() [1/2]

template<typename Widget >

Widget * Wt::WContainerWidget::insertBefore | ( | std::unique_ptr< Widget > | widget,
|  | WWidget * | before )

Inserts a child widget to this container, before another widget, returning a raw pointer.

This is implemented as:

Widget *result = widget.get();
insertBefore(std::unique_ptr<WWidget>(std::move(widget)), before);
return result;
Wt::WContainerWidget::insertBefore
virtual void insertBefore(std::unique_ptr< WWidget > widget, WWidget *before)
Inserts a child widget in this container, before another widget.

## ◆ insertBefore() [2/2]

virtual void Wt::WContainerWidget::insertBefore | ( | std::unique_ptr< WWidget > | widget,
|  | WWidget * | before )
| virtual

Inserts a child widget in this container, before another widget.

The widget is inserted at the place of the `before` widget, and subsequent widgets are shifted.

If, for some reason, you want to be in control of the lifetime of the widget, you can regain ownership of the widget (without any functional implication) using WObject::removeChild()

See also
  insertWidget(int index, WWidget *widget);

## ◆ insertNew()

template<typename Widget , typename ... Args>

Widget * Wt::WContainerWidget::insertNew | ( | int | index,
|  | Args &&... | args )

Creates a widget and inserts it, returning a reference to it.

This is implemented as:

std::unique_ptr<Widget> w{new Widget(std::forward<Args>(args)...)};
Widget *result = w.get();
insertWidget(index, std::unique_ptr<WWidget>{std::move(w)});
return result;
Wt::WContainerWidget::insertWidget
virtual void insertWidget(int index, std::unique_ptr< WWidget > widget)
Inserts a child widget in this container at given index.

## ◆ insertWidget() [1/2]

template<typename Widget >

Widget * Wt::WContainerWidget::insertWidget | ( | int | index,
|  | std::unique_ptr< Widget > | widget )

Inserts a child widget to this container at given index, returning a raw pointer.

This is implemented as:

Widget *result = widget.get();
insertWidget(index, std::unique_ptr<WWidget>(std::move(widget)));
return result;

## ◆ insertWidget() [2/2]

virtual void Wt::WContainerWidget::insertWidget | ( | int | index,
|  | std::unique_ptr< WWidget > | widget )
| virtual

Inserts a child widget in this container at given index.

The widget is inserted at the given `index`, and subsequent widgets are shifted.

If, for some reason, you want to be in control of the lifetime of the widget, you can regain ownership of the widget (without any functional implication) using WObject::removeChild()

See also
  insertBefore(WWidget *widget, WWidget *before);

Reimplemented in Wt::WStackedWidget.

## ◆ isList()

bool Wt::WContainerWidget::isList | ( |  | ) | const

Returns if this container is rendered as a List.

See also
  setList(), isOrderedList(), isUnorderedList()

## ◆ isOrderedList()

bool Wt::WContainerWidget::isOrderedList | ( |  | ) | const

Returns if this container is rendered as an Ordered List.

See also
  setList(), isList(), isUnorderedList()

## ◆ isUnorderedList()

bool Wt::WContainerWidget::isUnorderedList | ( |  | ) | const

Returns if this container is rendered as an Unordered List.

See also
  setList(), isList(), isOrderedList()

## ◆ layout()

WLayout * Wt::WContainerWidget::layout | ( |  | ) | const

Returns the layout manager that was set for the container.

If no layout manager was previously set using setLayout(WLayout *), 0 is returned.

See also
  setLayout(WLayout *)

## ◆ padding()

WLength Wt::WContainerWidget::padding | ( | Side | side | ) | const

Returns the padding set for the widget.

See also
  setPadding(const WLength&, WFlags<Side>)

## ◆ removeWidget() [1/2]

template<typename Widget >

std::unique_ptr< Widget > Wt::WWidget::removeWidget | ( | Widget * | widget | ) |

Removes a child widget.

This is an overload that automatically casts the returned value to a unique_ptr<Widget> for convenience

This is implemented as:

return std::unique_ptr<Widget>(static_cast<Widget*>(removeWidget(static_cast<WWidget*>(widget)).release()));
Wt::WContainerWidget::removeWidget
virtual std::unique_ptr< WWidget > removeWidget(WWidget *widget) override
Removes a child widget from this container.
Wt::WWidget
The abstract base class for a user-interface component.
Definition WWidget.h:66

## ◆ removeWidget() [2/2]

virtual std::unique_ptr< WWidget > Wt::WContainerWidget::removeWidget | ( | WWidget * | widget | ) |
| overridevirtual

Removes a child widget from this container.

If the WContainerWidget owns the given widget (i.e. if it was added with addWidget() or insertWidget() and not removed with WObject::removeChild()), a unique_ptr to this widget is returned. Otherwise, this returns nullptr.

Reimplemented from Wt::WWidget.

Reimplemented in Wt::WStackedWidget.

## ◆ scrolled()

EventSignal< WScrollEvent > & Wt::WContainerWidget::scrolled | ( |  | ) |

Event signal emitted when scrolling in the widget.

This event is emitted when the user scrolls in the widget (for setting the scroll bar policy, see setOverflow()). The event conveys details such as the new scroll bar position, the total contents height and the current widget height.

See also
  setOverflow()

## ◆ scrollLeft()

int Wt::WContainerWidget::scrollLeft | ( |  | ) | const

return the number of pixels the container is scrolled vertically

This value is only set if setOverflow() has been called

See also
  setOverflow()
  scrollTop();

## ◆ scrollTop()

int Wt::WContainerWidget::scrollTop | ( |  | ) | const

return the number of pixels the container is scrolled horizontally

This value is only set if setOverflow() has been called

See also
  setOverflow()
  scrollLeft();

## ◆ setContentAlignment()

void Wt::WContainerWidget::setContentAlignment | ( | WFlags< AlignmentFlag > | contentAlignment | ) |

Specifies how child widgets must be aligned within the container.

For a WContainerWidget, only specifes the horizontal alignment of child widgets. Note that there is no way to specify vertical alignment: children are always pushed to the top of the container.

For a WTableCell, this may also specify the vertical alignment. The default alignment is (Wt::AlignmentFlag::Top | Wt::AlignmentFlag::Left).

## ◆ setLayout() [1/2]

template<typename Layout >

Layout * Wt::WContainerWidget::setLayout | ( | std::unique_ptr< Layout > | layout | ) |

Sets a layout manager for the container, returning a raw pointer.

This is implemented as:

Layout *result = layout.get();
setLayout(std::unique_ptr<WLayout>(std::move(layout)));
return result;
Wt::WContainerWidget::setLayout
void setLayout(std::unique_ptr< WLayout > layout)
Sets a layout manager for the container.

This is a useful shorthand that allows to create a layout and get a raw pointer to it in one line.

## ◆ setLayout() [2/2]

void Wt::WContainerWidget::setLayout | ( | std::unique_ptr< WLayout > | layout | ) |

Sets a layout manager for the container.

Note that you can nest layout managers inside each other, to create a complex layout hierarchy.

If a previous layout manager was already set, it is first deleted. In that case, you will need to make sure that you either readd all widgets that were part of the previous layout to the new layout, or delete them, to avoid memory leaks.

See also
  layout()

## ◆ setList()

void Wt::WContainerWidget::setList | ( | bool | list,
|  | bool | ordered = false )

Renders the container as an HTML list.

Setting `renderList` to `true` will cause the container to be using an HTML `<ul>` or `<ol>` type, depending on the value of `orderedList`. This must be set before the initial render of the container. When set, any contained WContainerWidget will be rendered as an HTML `<li>`. Adding non-WContainerWidget children results in unspecified behaviour.

Note that CSS default layout rules for `<ul>` and `<ol>` add margin and padding to the container, which may look odd if you do not use bullets.

By default, a container is rendered using a `<div>` element.

See also
  isList(), isOrderedList(), isUnorderedList()

## ◆ setPadding()

void Wt::WContainerWidget::setPadding | ( | const WLength & | padding,
|  | WFlags< Side > | sides = AllSides )

Sets padding inside the widget.

Setting padding has the effect of adding distance between the widget children and the border.